/*
 * File         : test3.hpj
 * Author       : Qiang Zheng
 * Created      : Wed Oct 18 1998
 * Revision     : $Revision: 1.0 $
 * Updated      : $Date: 1998/10/14 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

// real a(10, 10), b(10, 10)
//
// !hpf$ distribute a (block, block) onto p
// !hpf$ align b (i, j) with a (j, i)
// !hpf$ processors p (2, 2)
//
// do i = 1, 10
//   do j = 1, 10
//     a (i, j) = 10 * i + j
//   enddo
// enddo
//
// b = a + 2
//
// do i = 1, 10
//   print "(10f7.1)", b(i, :)
// enddo
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test3 {
  static SpmdEnv	spmd;
  static Procs2		p;
  static Range		x,y;
  static Index		i,j;
  static Array2ddF	a,b,temp;
  // How to implement "!hpf$ align b (i, j) with a (j, i)" in hpjava?
  // It seems that zgs forgot that in adJava/test/test3.java

  public static void main(String argv[]) {
	spmd=new SpmdEnv(argv);

	p = new Procs2(2,2);
	
	if(p.on()) {
	x = new BlockRange(10,p.dim(0));
	y = new BlockRange(10,p.dim(1));

	i = new Index(x);
	j = new Index(y);

	a = new Array2ddF(spmd.apg,x,y);
	b = new Array2ddF(spmd.apg,x,y);
	temp = new Array2ddF(spmd.apg,x,y);

	i.dim().over();
	for(i.begin();i.test();i.next()) {
		j.dim().over();
		for(j.begin();j.test();j.next()) {
			a.dat()[a.pos(i,j)] = 10 * (x.idx(i) + 1) + y.idx(j) + 1;
		} j.dim().revo();
	} i.dim().revo();

    i.dim().over();
    for(i.begin();i.test();i.next()) {
        j.dim().over();
        for(j.begin();j.test();j.next()) {
            temp.dat()[temp.pos(i,j)] = a.dat()[a.pos(i,j)] + 2;
        } j.dim().revo();
    } i.dim().revo();

	Adlib.remap(b,temp);

	Adlib.aprintf("%7.1f%"+x.size()+"N", b);

	} p.no();
  }
}
